import { Command } from 'clime';
import { DeviceOptions } from '../../../options/device';
import { ReturnCode } from "@iotize/mcu-flasher.js";
import { Tap } from '@iotize/device-client.js/device';
import { TapNLinkUpdaterService } from '../../../../lib/tapnlink-admin/tapnlink-update.service';
import { FirmwareUpdateProviderType } from '../../../commands/device/firmware/update';
export interface ProgressStepInfo {
    stepName: string;
    stepIndex: number;
    endIndex: number;
    percentageState: number;
}
export declare class MyOptions extends DeviceOptions {
    version: string;
    skipTapnlink: boolean;
    force: boolean;
    chunkSize?: number;
    factoryReset: boolean;
    file: string;
    firmwareUpdateProvider: FirmwareUpdateProviderType;
}
export default class extends Command {
    tapnlinkUpdater: TapNLinkUpdaterService;
    execute(options: MyOptions): Promise<any>;
    _updateTapNLink(tap: Tap, options: MyOptions): Promise<any>;
    _updateTapNPass(tap: Tap, options: MyOptions): Promise<any>;
    _onError(err: Error): void;
    _checkErrorCode(name: string, code: ReturnCode): any;
}
