import { Command } from 'clime';
import { Response } from '@iotize/device-client.js/client/api/response';
import { DeviceOptions } from '../options/device';
import { IoTizeDevice } from '@iotize/device-client.js/device/iotize-device';
import { UartSettings } from '@iotize/device-client.js/device/model';
import { EncoderDecoder } from '@iotize/device-client.js/core/converter/encoder-decoder.interface';
import { UI } from '../../lib/ui';
export declare class MyOptions extends DeviceOptions {
    pollingPeriod: number;
    cr: boolean;
    lf: boolean;
}
export default class extends Command {
    device: IoTizeDevice;
    options: MyOptions;
    private pollingHandler?;
    displayConverter: EncoderDecoder<string, Uint8Array>;
    displayModeMenu: UI.Menu;
    displayType: string;
    execute(options: MyOptions): Promise<any>;
    login(): Promise<{
        username: string;
        password: string;
    }>;
    showIfResponseError(writeResponse: Response<any>, successMessage?: string): void;
    showDeviceInfo(responsePromise: Promise<Response<any>>, alias: string): Promise<void>;
    quit(): Promise<void>;
    transeive(): Promise<void>;
    stopDataPolling(): void;
    dataPolling(): void;
    appendReadResult(result: Response<Uint8Array>): void;
    configureSerial(config: UartSettings): Promise<void>;
    connectToTarget(): Promise<void>;
    askUserConfig(): Promise<any>;
    private getEnumInfos;
    private buildQuestionFromEnum;
}
