"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const clime_1 = require("clime");
const device_1 = require("../../../options/device");
const file_exists_1 = require("../../../validators/file-exists");
const device_extras_js_1 = require("@iotize/device-extras.js");
const inversify_config_1 = require("../../../../inversify.config");
const types_1 = require("../../../../types");
const fs_1 = require("fs");
class MyOptions extends device_1.DeviceOptions {
}
__decorate([
    clime_1.option({
        flag: 'f',
        description: 'Iotize script file to run (.iotz file)',
        required: false,
        default: global.getConfig('default.configScript', undefined),
        validator: new file_exists_1.FileExists()
    }),
    __metadata("design:type", String)
], MyOptions.prototype, "file", void 0);
exports.MyOptions = MyOptions;
let default_1 = class default_1 extends clime_1.Command {
    execute(options) {
        return __awaiter(this, void 0, void 0, function* () {
            let device = yield options.getDevice();
            let fileContent = fs_1.readFileSync(options.file).toString();
            let scriptRunner = inversify_config_1.container.get(types_1.TYPES.ScriptRunnerProvider)(device);
            let loader = new device_extras_js_1.TapScriptConfiguratorLoader(fileContent, scriptRunner);
            loader
                .configure(device)
                .subscribe({
                next: (event) => {
                    console.log(event);
                },
                complete: () => __awaiter(this, void 0, void 0, function* () {
                    yield device.disconnect();
                    global.output.success(`Script execution DONE!`);
                    process.exit(0);
                }),
                error: (err) => __awaiter(this, void 0, void 0, function* () {
                    global.output.error(`${err.toString()}`);
                    yield device.disconnect();
                    process.exit(err.code || 1);
                })
            });
        });
    }
};
__decorate([
    clime_1.metadata,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [MyOptions]),
    __metadata("design:returntype", Promise)
], default_1.prototype, "execute", null);
default_1 = __decorate([
    clime_1.command({
        description: 'Execute configuration script (.izsc). This scripts can be generated thanks to IoTize Studio',
    })
], default_1);
exports.default = default_1;
//# sourceMappingURL=exec.js.map