"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const clime_1 = require("clime");
const device_1 = require("../../../options/device");
class MyOptions extends device_1.DeviceOptions {
}
exports.MyOptions = MyOptions;
let default_1 = class default_1 extends clime_1.Command {
    execute(options) {
        return __awaiter(this, void 0, void 0, function* () {
            let device = yield options.getDevice();
            let mqttInfos = {};
            mqttInfos['Client Id'] = (yield device.service.interface.getCloudClientId()).body();
            mqttInfos['Login'] = (yield device.service.interface.getCloudLogin()).body();
            mqttInfos['Passowrd'] = (yield device.service.interface.getCloudPassword()).body();
            mqttInfos['Gateway URL'] = (yield device.service.interface.getCloudGatewayUrl()).body();
            mqttInfos['Data Log Options'] = (yield device.service.datalog.getOptions()).body();
            mqttInfos['Number of packet'] = (yield device.service.datalog.getPacketCount()).body();
            mqttInfos['Period'] = (yield device.service.interface.getUploadPeriod()).body();
            global.output.pretty(mqttInfos);
            yield device.disconnect();
            process.exit(0);
        });
    }
};
__decorate([
    clime_1.metadata,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [MyOptions]),
    __metadata("design:returntype", Promise)
], default_1.prototype, "execute", null);
default_1 = __decorate([
    clime_1.command({
        description: 'Show datalog infos ',
    })
], default_1);
exports.default = default_1;
//# sourceMappingURL=info.js.map