import { Command } from 'clime';
import { DeviceOptions } from '../../../options/device';
import { Response } from '@iotize/device-client.js/client/api/response';
import { IoTizeDevice } from '@iotize/device-client.js/device/iotize-device';
import { IotizeConfigModel } from '@iotize/device-config.js/model/iotize-config-model';
import { SinglePacket as SinglePacketModel } from "@iotize/device-client.js/device/model";
export declare class MyOptions extends DeviceOptions {
    period: number;
    mqttGateway?: string;
    mqttTopic: string;
    format: 'singlepacket' | 'json';
    action: 'mqtt' | 'print' | 'firebase';
}
export default class extends Command {
    options?: MyOptions;
    execute(options: MyOptions): Promise<void>;
    doActionWithPacket(device: IoTizeDevice, options: MyOptions, response: Response<SinglePacketModel>): Promise<void>;
    getBundleFromVariable(config: IotizeConfigModel, data: {
        [key: string]: any;
    }): string;
    converter(data: Uint8Array): void;
}
