"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const clime_1 = require("clime");
const rxjs_1 = require("rxjs");
const response_error_1 = require("@iotize/device-client.js/client/api/response/response-error");
const device_1 = require("../../../options/device");
const in_list_1 = require("../../../validators/in-list");
const TlvBundleConverter_1 = require("@iotize/device-client.js/device/extra-converter/TlvBundleConverter");
class MyOptions extends device_1.DeviceOptions {
}
__decorate([
    clime_1.option({
        flag: 'p',
        description: 'Data logging period (in milliseconds)',
        required: false,
        default: 1000
    }),
    __metadata("design:type", Number)
], MyOptions.prototype, "period", void 0);
__decorate([
    clime_1.option({
        description: 'Gateway url. By default, it\' is read from the device',
        required: false,
    }),
    __metadata("design:type", String)
], MyOptions.prototype, "mqttGateway", void 0);
__decorate([
    clime_1.option({
        description: 'Topic',
        required: false,
        default: 'IOTIZE_CLOUD/{serialNumber}/DATALOG'
    }),
    __metadata("design:type", String)
], MyOptions.prototype, "mqttTopic", void 0);
__decorate([
    clime_1.option({
        description: 'Data format to transfert [singlepacket | json]',
        required: false,
        default: 'singlepacket',
        validator: new in_list_1.InListValidator([
            'singlepacket',
            'json'
        ])
    }),
    __metadata("design:type", String)
], MyOptions.prototype, "format", void 0);
__decorate([
    clime_1.option({
        description: 'Action to do with the packet [print | mqtt]',
        required: false,
        default: 'print',
        validator: new in_list_1.InListValidator([
            'mqtt',
            'print',
            'firebase'
        ])
    }),
    __metadata("design:type", String)
], MyOptions.prototype, "action", void 0);
exports.MyOptions = MyOptions;
let default_1 = class default_1 extends clime_1.Command {
    execute(options) {
        return __awaiter(this, void 0, void 0, function* () {
            throw new Error(`Not implemented yet`);
            this.options = options;
            let device = yield options.getDevice();
            let nbOfPackets = (yield device.service.datalog.getPacketCount()).body();
            global.output.infonl(`Packet count: ${nbOfPackets}`);
            // let _uploader: Cloud.DataLogUploader;
            switch (options.action) {
                case 'mqtt':
                    let mqttInfos = {};
                    mqttInfos.clientId = (yield device.service.interface.getCloudClientId());
                    mqttInfos.login = (yield device.service.interface.getCloudLogin());
                    mqttInfos.password = (yield device.service.interface.getCloudPassword());
                    mqttInfos.gatewayUrl = options.mqttGateway || (yield device.service.interface.getCloudGatewayUrl());
                    break;
                case 'firebase':
                // let serialNumber: string = (await device.service.device.getSerialNumber()).body()!;
                // this._uploader = this.getCloudApp().device(serialNumber).datalog.uploader;
            }
            if (!options.period) {
                options.period = (yield device.service.interface.getUploadPeriod()).body();
            }
            if (options.period < 100) {
                throw new Error(`Period is too small. ${options.period}`);
            }
            let source = rxjs_1.interval(options.period);
            global.output.message(`Start datalogging with periodicity of ${options.period} milliseconds`);
            let subscription = source.subscribe((time) => __awaiter(this, void 0, void 0, function* () {
                console.log(`\- new check: ${time}`);
                let response = yield device.service.datalog.dequeueOnePacket();
                if (response.isSuccess()) {
                    // global.output.pretty(response.body());
                    yield this.doActionWithPacket(device, options, response);
                }
                else {
                    global.output.error(`${new response_error_1.ResponseError(response)}`);
                }
            }));
            process.on('SIGINT', () => {
                subscription.unsubscribe();
                process.exit(0);
            });
        });
    }
    doActionWithPacket(device, options, response) {
        return __awaiter(this, void 0, void 0, function* () {
            if (options.format) {
                // TODO 
            }
            let singlePacket = response.body();
            console.log(`Packet => ${singlePacket}`);
            let data = singlePacket.data;
            let senderId = singlePacket.senderId;
            let time = singlePacket.logTime;
            let bundleConverter = new TlvBundleConverter_1.TlvBundleConverter(device.variables);
            let bundleData = bundleConverter.decode(data);
            // Find bundle from variable ? 
            if (!this.options) {
                throw new Error("Internal error options should not be null");
            }
            let bundleId = this.getBundleFromVariable(this.options.getConfigModel(), bundleData);
            // if (this._uploader) {
            //     this._uploader.uploadOne(bundleId, time, bundleData); //TODO
            // }
            switch (options.action) {
                case 'print':
                    global.output.pretty(response.body());
                    break;
                // default:
                //     throw new Error(`Action "${options.action}" is not implemented yet`);
            }
        });
    }
    getBundleFromVariable(config, data) {
        if (!config) {
            throw new Error('Configuration is required to deduce bundles');
        }
        for (let variableId in data) {
            let variableConfig = config.variable(variableId);
            if (variableConfig) {
                variableConfig.bundle().name();
            }
        }
        throw new Error("Cannot deduce bundle from variable");
    }
    converter(data) {
        // let singlepacket = new SinglePacketConverter(new TLVConverter('/var/inst')).decode(data);
        // TODO decode each values
        // Need configuration file 
        throw new Error('Not implemented yet');
    }
};
__decorate([
    clime_1.metadata,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [MyOptions]),
    __metadata("design:returntype", Promise)
], default_1.prototype, "execute", null);
default_1 = __decorate([
    clime_1.command({
        description: 'Run datalog ',
    })
], default_1);
exports.default = default_1;
//# sourceMappingURL=run.js.map