"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const clime_1 = require("clime");
// import { Client, Protocol } from '@'../../iotize/device-client.js';
const device_client_js_1 = require("@iotize/device-client.js");
// import { TypedIoTizeClient } from '@iotize/awesome-device-client.js';
const shell_grammar_js_1 = require("@iotize/shell-grammar.js");
var FormatHelper = device_client_js_1.Core.FormatHelper;
const method_type_1 = require("@iotize/device-client.js/client/api/request/method-type");
const response_error_1 = require("@iotize/device-client.js/client/api/response/response-error");
const device_1 = require("../../options/device");
class MyOptions extends device_1.DeviceOptions {
}
__decorate([
    clime_1.option({
        description: 'Command to run',
        required: false,
    }),
    __metadata("design:type", String)
], MyOptions.prototype, "command", void 0);
exports.MyOptions = MyOptions;
let default_1 = class default_1 extends clime_1.Command {
    constructor() {
        super(...arguments);
        this.commandBuilder = new shell_grammar_js_1.CommandBuilder();
    }
    execute(options) {
        return __awaiter(this, void 0, void 0, function* () {
            this.device = yield options.getDevice();
            if (options.command) {
                yield this.interpretCommand(options.command);
            }
            else {
                global.output.message("Starting interactive session... \n");
                yield this.runInteractiveShell();
            }
            yield this.finish();
        });
    }
    runInteractiveShell() {
        return this
            .waitForCommand()
            .then((continueLooping) => {
            if (continueLooping) {
                return this.runInteractiveShell();
            }
            else {
                return Promise.resolve(false);
            }
        });
    }
    waitForCommand() {
        var commandString = global.input.read("");
        if (commandString == 'quit') {
            return Promise.resolve(false);
        }
        else {
            return this
                .interpretCommand(commandString)
                .catch((err) => {
                global.output.error(err.toString());
            })
                .then(() => {
                return true;
            });
        }
    }
    interpretCommand(commandString) {
        try {
            var command = shell_grammar_js_1.CommandBuilder.fromString(commandString);
        }
        catch (err) {
            return Promise.reject(`Invalid syntax! `);
        }
        let promise = this.device.lwm2m.call({
            path: command.getCommandUrl(),
            methodType: method_type_1.MethodType[command.getMethod()]
        });
        // let promise = this.client.command(command as any).toPromise();
        console.log("Waiting for promise resolve...");
        return promise
            .then((result) => {
            if (result.isSuccess()) {
                var formattedResponse = "";
                if (result.hasBody()) {
                    // var content = ";
                    // formattedResponse += "  - hex: " + FormatHelper.toHexString(result.rawBody()!) + " - ascii: " + content;
                    let body = result.body();
                    if (body instanceof Uint8Array) {
                        formattedResponse = FormatHelper.toHexString(body);
                    }
                    else if (typeof body === "object") {
                        formattedResponse = JSON.stringify(body);
                    }
                    else {
                        formattedResponse = body;
                    }
                }
                else {
                    formattedResponse = "[NO RESPONSE]";
                }
                global.output.success(formattedResponse);
            }
            else {
                global.output.error(` > ${new response_error_1.ResponseError(result)}`);
            }
        })
            .catch((err) => {
            global.output.error(err);
        });
    }
    finish() {
        return __awaiter(this, void 0, void 0, function* () {
            // global.output.info("Quit!");
            if (this.device) {
                yield this.device.disconnect();
            }
            process.exit(0);
        });
    }
};
__decorate([
    clime_1.metadata,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [MyOptions]),
    __metadata("design:returntype", Promise)
], default_1.prototype, "execute", null);
default_1 = __decorate([
    clime_1.command({
        description: 'Connect to an iotize device',
    })
], default_1);
exports.default = default_1;
//# sourceMappingURL=interactive.js.map