"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const clime_1 = require("clime");
const device_1 = require("../../../options/device");
const variable_1 = require("@iotize/device-client.js/device/target-variable/variable");
const impl_1 = require("@iotize/device-client.js/client/impl");
const format_helper_1 = require("@iotize/device-client.js/core/format/format-helper");
class MyOptions extends device_1.DeviceOptions {
}
__decorate([
    clime_1.option({
        flag: 's',
        description: 'Set value',
        required: false
    }),
    __metadata("design:type", String)
], MyOptions.prototype, "set", void 0);
__decorate([
    clime_1.option({
        flag: 'g',
        description: 'Get value',
        required: false,
        toggle: true
    }),
    __metadata("design:type", Boolean)
], MyOptions.prototype, "get", void 0);
__decorate([
    clime_1.option({
        description: 'Identifier',
        required: false
    }),
    __metadata("design:type", Number)
], MyOptions.prototype, "id", void 0);
__decorate([
    clime_1.option({
        description: 'List configured variables',
        required: false,
        toggle: true
    }),
    __metadata("design:type", Boolean)
], MyOptions.prototype, "list", void 0);
__decorate([
    clime_1.option({
        description: 'Variable name',
        required: false,
    }),
    __metadata("design:type", String)
], MyOptions.prototype, "name", void 0);
exports.MyOptions = MyOptions;
let default_1 = class default_1 extends clime_1.Command {
    execute(options) {
        return __awaiter(this, void 0, void 0, function* () {
            let device = yield options.getDevice();
            if (!options.id && !options.name && !options.list) {
                throw new clime_1.ExpectedError(`At least id, name or list option is expected`);
            }
            let configModel = undefined;
            if (options.config) {
                //global.output.info('Using configuration file...');
                configModel = options.getConfigModel();
            }
            if (options.list) {
                if (!configModel) {
                    throw new clime_1.ExpectedError(`You must give a configuration file to list configured variables`);
                }
                for (let varId in device.variables.variables) {
                    let variable = device.variables.getById(varId);
                    let variableConfigModel = configModel.variable(variable.variableId.toString());
                    global.output.infonl(`${variableConfigModel.name()} (id=${variableConfigModel.id()}) value size=${variableConfigModel.valueSize()} ${variableConfigModel.valueQuantity() > 1 ? ` | Array of ${variableConfigModel.valueQuantity()} elements` : ''}`);
                }
            }
            else {
                let variable;
                if (options.id) {
                    try {
                        variable = device.variables.getById(options.id);
                    }
                    catch (ex) {
                        console.log(`No variable defined. Creating custom variable`);
                        variable = variable_1.VariableConfig.create(options.name || (options.id || 0).toString(), options.id || 0, device.service.variable, impl_1.HexStringConverter.instance());
                    }
                }
                else { //if (options.name){
                    variable = device.variables.get(options.name);
                }
                let converter;
                if (variable instanceof variable_1.VariableConfig) {
                    converter = variable.converter;
                }
                if (options.set) {
                    let value = options.set;
                    if (!converter) {
                        // TODO add default converter ? 
                        throw new Error(`Converter for variable is undefined`);
                    }
                    let encodedValue = converter.encode(value);
                    let result = yield variable.write(value);
                    global.output.message(`Value write ${value} (encoded data: ${encodedValue ? format_helper_1.FormatHelper.toHexString(encodedValue) : 'NULL'})`);
                }
                else {
                    let result = yield variable.read();
                    global.output.message(`${result}`);
                }
            }
            yield device.disconnect();
            process.exit(0);
        });
    }
};
__decorate([
    clime_1.metadata,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [MyOptions]),
    __metadata("design:returntype", Promise)
], default_1.prototype, "execute", null);
default_1 = __decorate([
    clime_1.command({
        description: 'Monitor variables',
    })
], default_1);
exports.default = default_1;
//# sourceMappingURL=default.js.map