import { Command, Options } from 'clime';
import { ComProtocol } from '@iotize/device-client.js/protocol/api';
import { RelayServer, ComRelay } from '@iotize/device-client.js/relay/impl';
export declare class RelayOptions extends Options {
    protocol: string;
    local: boolean;
    device?: string;
    createServer: boolean;
    socketPort: number;
    websocketPort: number;
    timeout: number;
    duration?: number;
    autoRestart?: number;
}
/**
 * iode relay --device XXX
 * iode relay --socket
 * iode relay --websocket
 */
export default class extends Command {
    relays: ComRelay[];
    servers: RelayServer[];
    onExit(): Promise<any>;
    execute(options: RelayOptions): Promise<any>;
    createServer(sourceProtocol: ComProtocol, options: RelayOptions): RelayServer;
    createTargetProtocol(options: RelayOptions): Promise<ComProtocol>;
    createSourceProtocol(url: string): Promise<ComProtocol>;
}
