"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const clime_1 = require("clime");
const util_1 = require("../../tools/util");
const inversify_config_1 = require("../../inversify.config");
const types_1 = require("../../types");
class ScanOptions extends clime_1.Options {
}
__decorate([
    clime_1.option({
        flag: 'd',
        description: 'Scan duration in milliseconds (0 for infinite). By default, it will run forever.',
        required: false,
        default: 0
    }),
    __metadata("design:type", Number)
], ScanOptions.prototype, "duration", void 0);
__decorate([
    clime_1.option({
        flag: 'a',
        description: 'Show all devices (do not show only IoTize devices)',
        required: false,
        default: false,
        toggle: true
    }),
    __metadata("design:type", Boolean)
], ScanOptions.prototype, "all", void 0);
__decorate([
    clime_1.option({
        description: 'Skip wifi scan',
        required: false,
        default: false,
        toggle: true
    }),
    __metadata("design:type", Boolean)
], ScanOptions.prototype, "skipWifi", void 0);
__decorate([
    clime_1.option({
        description: 'Skip ble scan',
        required: false,
        default: false,
        toggle: true
    }),
    __metadata("design:type", Boolean)
], ScanOptions.prototype, "skipBle", void 0);
exports.ScanOptions = ScanOptions;
let default_1 = class default_1 extends clime_1.Command {
    execute(options) {
        return __awaiter(this, void 0, void 0, function* () {
            let scanner = yield inversify_config_1.container.get(types_1.TYPES.DeviceScannerProvider)();
            console.log(scanner.bleScanner);
            scanner
                .startScan({
                protocols: {
                    'WIFI': !options.skipWifi,
                    'BLE': !options.skipBle
                },
                duration: options.duration
            })
                .subscribe({
                next: (scannedDevice) => {
                    if (options.all || util_1.Util.isIoTizeName(scannedDevice.name)) {
                        global.output.success(`\t- [${scannedDevice.type}]   ${scannedDevice.name} - Address: ${scannedDevice.address}`);
                    }
                },
                complete: () => {
                    global.output.info(`Scan finished!`);
                },
                error: (error) => {
                    global.output.error(error);
                }
            });
        });
    }
};
__decorate([
    clime_1.metadata,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [ScanOptions]),
    __metadata("design:returntype", Promise)
], default_1.prototype, "execute", null);
default_1 = __decorate([
    clime_1.command({
        description: 'Scan devices with Wifi or BLE (if enabled)',
    })
], default_1);
exports.default = default_1;
//# sourceMappingURL=scan.js.map