"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const clime_1 = require("clime");
const relay_server_factory_1 = require("../../tools/relay/relay-server-factory");
const constants_1 = require("../constants");
class ServerOptions extends clime_1.Options {
}
__decorate([
    clime_1.option({
        description: 'Server port',
        required: false,
        default: constants_1.Constants.DEFAULT_SERVER_PORT
    }),
    __metadata("design:type", Number)
], ServerOptions.prototype, "port", void 0);
__decorate([
    clime_1.option({
        description: 'Server type',
        required: false,
        default: "websocket"
    }),
    __metadata("design:type", String)
], ServerOptions.prototype, "type", void 0);
exports.ServerOptions = ServerOptions;
let default_1 = class default_1 extends clime_1.Command {
    execute(options) {
        let relayServer = relay_server_factory_1.RelayServerFactory.fromType(options.type, {
            port: options.port
        });
        return relayServer
            .start()
            .then(() => {
            global.output.infonl(`${options.type} server is running on ${options.port}...`);
        });
    }
};
__decorate([
    clime_1.metadata,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [ServerOptions]),
    __metadata("design:returntype", void 0)
], default_1.prototype, "execute", null);
default_1 = __decorate([
    clime_1.command({
        description: 'Start a relay server',
    })
], default_1);
exports.default = default_1;
//# sourceMappingURL=server.js.map