"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const console_helper_1 = require("../tools/console-helper");
// // Log level
let config = global.configProvider.config();
let logLevel = config.get('loglevel', "info").trim().toLowerCase();
let logLevelIndex = process.argv.indexOf('--loglevel');
if (logLevelIndex > 0) {
    if (process.argv.length >= logLevelIndex + 2) {
        logLevel = process.argv[logLevelIndex + 1];
        process.argv.splice(logLevelIndex, 2);
    }
    else {
        throw new Error('Missing value after --loglevel');
    }
}
let allowedLogLevel = ['debug', 'info', 'warn', 'error', 'none'];
if (allowedLogLevel.indexOf(logLevel) < 0) {
    global.output.error('Invalid log level "' + logLevel + '" in config. Expected one of these: ' + allowedLogLevel.join(', '));
    logLevel = 'info';
}
console_helper_1.ConsoleHelper.level(logLevel);
//# sourceMappingURL=configure-log.js.map