"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
class OptionHelper {
    static defaultDevice() {
        return global.getConfig('default.device');
    }
    static logFromOptions(device, options) {
        return __awaiter(this, void 0, void 0, function* () {
            if (options.credentials) {
                let parts = options.credentials.split(":");
                let success = yield device.login(parts[0], parts[1]);
                if (!success) {
                    console.warn(`Login was not successful...`); // TODO 
                    // throw new Error("Cannot login with this credentials");
                }
                return success;
            }
            else {
                return Promise.resolve(false);
            }
        });
    }
}
OptionHelper.OPTION_DEVICE = {
    description: 'The IoTize device to connect to. For example ble:fb:f4:c2:4e:4e:af for BLE with device address fb:f4:c2:4e:4e:af)',
    required: false,
    default: OptionHelper.defaultDevice(),
    flag: "d"
};
exports.OptionHelper = OptionHelper;
//# sourceMappingURL=option-helper.js.map