"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
const config_file_1 = require("./config-file");
class ConfigProvider {
    constructor(options) {
        this.options = options;
    }
    set template(value) {
        this._template = value;
    }
    get template() {
        return this._template;
    }
    hasProfile() {
        return Boolean(this._profileName);
    }
    config() {
        if (!this._profileConfig) {
            throw new Error('Profile config has not been loaded yet');
        }
        return this._profileConfig;
        // return Object.assign({}, this.defaultConfig().data, this.profileConfig().data);
    }
    getProfileName() {
        return this._profileName;
    }
    setProfile(profile) {
        if (!profile) {
            throw new Error('Cannot set undefined profile');
        }
        this._profileName = profile;
        this._profileConfig = new config_file_1.ConfigFile(this._getProfileDataFilename(), this._template);
        this._profileConfig.load().save();
        return this;
    }
    _getProfileDataFilename(profile) {
        profile = profile || this._profileName;
        return path_1.resolve(this.options.basePath, (profile ? profile : ""), 'config.json');
    }
}
exports.ConfigProvider = ConfigProvider;
//# sourceMappingURL=config-provider.js.map