export declare type LogLevelType = 'debug' | 'info' | 'warn' | 'error' | 'none';
export interface ConfigInterface {
    /**
     * Log level
     */
    loglevel?: LogLevelType;
    alias?: {
        [key: string]: string;
    };
    /**
     * Default values
     */
    default?: {
        [key: string]: string;
    };
    firmwareUpdateServer?: {
        url: string;
    };
    firebase?: {
        apiKey?: string;
        authDomain?: string;
        databaseURL?: string;
        projectId?: string;
        storageBucket?: string;
        messagingSenderId?: string;
    };
    [key: string]: any;
}
