import * as axios from "axios";
export interface FirmwareUpdateProvider {
    getForDevice(sn: string, version: string): Promise<Uint8Array>;
    getLatestVersion(sn: string): Promise<string>;
}
export declare class RestFirmwareUpdateProvider implements FirmwareUpdateProvider {
    private config;
    private api;
    constructor(config: axios.AxiosRequestConfig);
    getLatestVersion(sn: string): Promise<string>;
    getForDevice(sn: string, version: string): Promise<Uint8Array>;
}
export declare class S3FirmwareUpdateProvider implements FirmwareUpdateProvider {
    private config;
    private api;
    constructor(config: {
        bucket: string;
        region: string;
    });
    getLatestVersion(sn: string): Promise<string>;
    getForDevice(sn: string, version: string): Promise<Uint8Array>;
}
