"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Colors = require("colors");
const prettyjson = require("prettyjson");
const ProgressBar = require("progress");
class Output {
    progressBar(format, options) {
        let defaults = {
            width: 40,
            complete: '=',
            incomplete: ' ',
            stream: process.stdout
        };
        let optionsWithDefault = Object.assign(defaults, options);
        return new ProgressBar(format, optionsWithDefault);
    }
    success(message) {
        this.writenl(Colors.green(message));
    }
    message(message) {
        this.writenl(message);
    }
    infonl(message) {
        this.writenl(Colors.cyan(message));
    }
    info(message) {
        this.write(Colors.cyan(message));
    }
    warn(message) {
        this.writenl(Colors.red(message));
    }
    error(message) {
        this.writenl(Colors.red(message));
    }
    json(message) {
        return this.writenl(JSON.stringify(message, null, 4));
    }
    pretty(object) {
        // this.writenl("Object to print: ", object);
        object = JSON.parse(JSON.stringify(object));
        let content;
        try {
            content = prettyjson.render(object);
        }
        catch (err) {
            this.error('Cannot prettify output due to error: ' + err);
            content = object;
        }
        this.message(content);
    }
    writenl(message) {
        process.stdout.write(message + '\n');
    }
    write(message) {
        process.stdout.write(message);
    }
}
exports.Output = Output;
//# sourceMappingURL=output.js.map