"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const rxjs_1 = require("rxjs");
const mcu_flasher_js_1 = require("@iotize/mcu-flasher.js");
class TapnPassUpdater {
    constructor() {
    }
    update(mcuDeveloper, programString) {
        if (this._progress) {
            return this._progress;
        }
        this._progress = new rxjs_1.Subject();
        this._update(mcuDeveloper, programString, this._progress);
        return this._progress;
    }
    _update(mcuDeveloper, programString, observer) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                yield mcuDeveloper.informationStates().subscribe((event) => {
                    observer.next(event);
                });
                // observer.next({
                //     type: 'BLANK_CHECK_START',
                //     message: "Starting blank check"
                // });
                this._checkErrorCode('blankCheck', yield mcuDeveloper.blankCheck());
                // observer.next({
                //     type: 'BLANK_CHECK_DONE',
                //     message: "Blank check done"
                // })
                this._checkErrorCode('erase', yield mcuDeveloper.erase());
                this._checkErrorCode('blankCheck', yield mcuDeveloper.blankCheck());
                this._checkErrorCode('programFile', yield mcuDeveloper.programFile(programString));
                // observer.next({
                //     type: 'PROGRAM_FILE',
                //     message: "Programing done"
                // })
                this._checkErrorCode('run', yield mcuDeveloper.run());
                // observer.next({
                //     type: 'RUN',
                //     message: "Run done"
                // })
                observer.complete();
            }
            catch (err) {
                observer.error(err);
            }
            this._progress = undefined;
        });
    }
    _checkErrorCode(name, code) {
        if (code != mcu_flasher_js_1.ReturnCode.DNG_ERR_OK) {
            throw new Error(`Command failed ${name} with error code ${code}`);
        }
    }
}
exports.TapnPassUpdater = TapnPassUpdater;
//# sourceMappingURL=tapnpass-update.service.js.map