"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const inquirer_1 = require("inquirer");
var UI;
(function (UI) {
    class Menu {
        constructor() {
            this.actions = {};
        }
        action(name, action) {
            this.actions[name] = action;
            return this;
        }
        default(callback) {
            this._default = callback;
        }
        show(msg) {
            return __awaiter(this, void 0, void 0, function* () {
                let result = yield inquirer_1.prompt({
                    message: msg,
                    name: 'action',
                    type: 'list',
                    choices: Object.keys(this.actions)
                });
                let action = result.action;
                if (action in this.actions) {
                    return this.actions[action](action);
                }
                else {
                    if (this._default) {
                        return this._default(action);
                    }
                    else {
                        return Promise.reject(new Error(`Unkown action ${action}`));
                    }
                }
            });
        }
    }
    UI.Menu = Menu;
})(UI = exports.UI || (exports.UI = {}));
//# sourceMappingURL=index.js.map