"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const protocol_factory_1 = require("./protocol-factory");
const device_1 = require("@iotize/device-client.js/device");
const impl_1 = require("@iotize/device-client.js/protocol/impl");
class DeviceFactory {
    static fromUrl(url, connect = false) {
        return __awaiter(this, void 0, void 0, function* () {
            let protocol = yield protocol_factory_1.ProtocolFactory.fromUrl(url);
            if (protocol instanceof impl_1.AbstractComProtocol) {
                protocol.options.connect.timeout = 5000; // TODO use as an options
                console.log('DeviceFactory', `Connection timeout will be ${protocol.options.connect.timeout}`);
            }
            let device = device_1.IoTizeDevice.fromProtocol(protocol);
            if (connect) {
                console.log('DeviceFactory', `Attempt connection...`);
                yield device.connect();
            }
            return device;
        });
    }
}
exports.DeviceFactory = DeviceFactory;
//# sourceMappingURL=device-factory.js.map