import { Observable } from 'rxjs';
import { WifiDeviceScanner } from './wifi-device-scanner';
import { NobleBleScanner } from '@iotize/device-com-ble.node/lib';
import { ScanItem } from './scan-item';
export interface DeviceScannerOptions {
    protocols?: {
        [key: string]: any;
    };
    duration?: number | 'infinite';
    iotizeDeviceOnly?: boolean;
}
export declare type DeviceScannerProvider = () => Promise<DeviceScanner>;
export declare namespace DeviceScanner {
    interface Options {
        bleDelay: number;
    }
}
export declare class DeviceScanner {
    observables: Observable<ScanItem<any>>[];
    bleScanner: NobleBleScanner;
    wifiDeviceScanner: WifiDeviceScanner;
    options: DeviceScanner.Options;
    constructor(bleScanner: NobleBleScanner);
    startScan(options?: DeviceScannerOptions): Observable<ScanItem<any>>;
    stopScan(): void;
}
