"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const rxjs_1 = require("rxjs");
const wifi_device_scanner_1 = require("./wifi-device-scanner");
const lib_1 = require("@iotize/device-com-ble.node/lib");
const operators_1 = require("rxjs/operators");
const inversify_1 = require("inversify");
let DeviceScanner = class DeviceScanner {
    constructor(bleScanner) {
        this.observables = [];
        this.options = {
            bleDelay: 500
        };
        this.wifiDeviceScanner = new wifi_device_scanner_1.WifiDeviceScanner();
        this.bleScanner = bleScanner;
    }
    startScan(options) {
        if (!options) {
            options = {};
        }
        if (!options.protocols) {
            options.protocols = {
                "WIFI": true,
                "BLE": true
            };
        }
        if (options.protocols['WIFI']) {
            let wifiObservable = this.wifiDeviceScanner.startScan()
                .pipe(operators_1.map((item) => {
                return {
                    type: "WIFI",
                    name: item.ssid,
                    payload: item,
                    address: item.bssid
                };
            }));
            this.observables.push(wifiObservable);
        }
        if (options.protocols['BLE']) {
            // this.bleScanner.on("discover", (peripheral: Peripheral) => {
            //     bleObservable.next({
            //         type: "BLE",
            //         payload: peripheral,
            //         name: peripheral.advertisement.localName,
            //         address: peripheral.address
            //     });
            // });
            // try {
            let bleObservable = this.bleScanner.start({
                timeout: options.duration === 'infinite' || options.duration === 0 ? undefined : options.duration
            })
                .pipe(operators_1.delay(this.options.bleDelay), // Due to a bug with noble-uwp when name is poplated afeter a delay
            operators_1.map((peripheral) => {
                let advertisement = peripheral.advertisement;
                return {
                    type: "BLE",
                    payload: peripheral,
                    name: advertisement.localName || 'UNKNOWN NAME',
                    address: peripheral.address
                }; // : ScanItem<noble.Peripheral>;
            }));
            this.observables.push(bleObservable);
            // }
            // catch (err) {
            //     // this.observables.push({
            //     //     type: 'error',
            //     //     payload: err
            //     // });
            //     console.error(err);
            // }
        }
        return rxjs_1.merge(...this.observables);
    }
    stopScan() {
        // for (let scanner of this.observables){
        //     scanner.complete();
        // }
        this.wifiDeviceScanner.stopScan();
        this.bleScanner.stop();
    }
};
DeviceScanner = __decorate([
    inversify_1.injectable(),
    __metadata("design:paramtypes", [lib_1.NobleBleScanner])
], DeviceScanner);
exports.DeviceScanner = DeviceScanner;
//# sourceMappingURL=device-scanner.js.map