"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rxjs_1 = require("rxjs");
var nodeWifi = require('node-wifi');
/*
networks = [
    {
    ssid: '...',
    bssid: '...',
    mac: '...', // equals to bssid (for retrocompatibility)
    channel: <number>,
    frequency: <number>, // in MHz
    signal_level: <number>, // in dB
    security: 'WPA WPA2' // format depending on locale for open networks in Windows
    security_flags: '...' // encryption protocols (format currently depending of the OS)
    mode: '...' // network mode like Infra (format currently depending of the OS)
    },
    ...
];
*/
class WifiDeviceScanner {
    constructor() {
        this.wifi = nodeWifi;
        // Initialize wifi module
        // Absolutely necessary even to set interface to null
        this.wifi.init({
            iface: null // network interface, choose a random wifi interface if set to null
        });
    }
    startScan() {
        let subject = new rxjs_1.Subject();
        // Scan networks
        this.wifi.scan(function (err, networks) {
            if (err) {
                console.error(err);
                subject.error(err);
            }
            else {
                // console.log(networks);
                for (let network of networks) {
                    subject.next(network);
                }
            }
        });
        return subject;
    }
    stopScan() {
    }
}
exports.WifiDeviceScanner = WifiDeviceScanner;
//# sourceMappingURL=wifi-device-scanner.js.map