import { IotizeVariableModel } from "@iotize/device-config.js/model";
import { NumberConverter } from "@iotize/device-client.js/client/impl/converter/body/number-decoder";
import { FloatConverter } from "@iotize/device-client.js/client/impl/converter/body/float-converter";
import { Response } from "@iotize/device-client.js/client/api/response";
export declare function getContent(url: string): Promise<string>;
export declare class Util {
    static glob(file: string): Promise<string[]>;
    static asyncTryCatch<T>(fct: () => Promise<T>): Promise<T>;
    static IS_IOTIZE_NAME_REGEX: RegExp;
    /**
     * Return true if it's a valid IoTize name
     * @param name
     */
    static isIoTizeName(name: string): boolean;
    static sleep(ms: number): Promise<{}>;
    static getConverterFromVariableModel(variable: IotizeVariableModel): NumberConverter | FloatConverter;
    static _successfull<T>(call: Promise<Response<T>>): Promise<Response<T>>;
    static _body<T>(call: Promise<Response<T>>): Promise<T>;
}
